/* Copyright 2002  	Jarek Pelczar				      */
/* 			jarekp3@wp.pl				      */

/* tutor1.c - First Hello World application that we create for Menuet */

#include<menuet/os.h>	/* Here we include standard MenuetOS header */
#include<string.h>	/* strlen */

static char * WindowTitle="Hello World App"; /* Our window caption */
static char * Text1="Hello World !!!";

void window_redraw_proc(void) /* Main window needs a redraw function */
{
/* Firstly tell Menuet that we want to begin redrawing */
 __menuet__window_redraw(1);
/* After that we create window, e.g. 200x200 at (100,100) */
 __menuet__define_window(100,100,200,200,0x000080,0x800000,0x808080);
 __menuet__bar(0,0,200,20,800000);	/* xxx - do we need this ? */
/* Then create close button. We want to exit this app normally, don't we ? ;) */
/*            Our exit button id is 1 \/ */
 __menuet__make_button(200-30,2,15,15,1,0x008000);
/* Write some text to button e.g. 'x'. Then we know what is this button for */
 __menuet__write_text(200-30+3,2+3,0xFFFFFF,"x",1);
/* Draw window caption */
 __menuet__write_text(2,3,0xFFFFFF,WindowTitle,strlen(WindowTitle));
/* Write 'Hello World !!!' text at pos (50,15) with color 0xFFFFFF */
 __menuet__write_text(15,50,0xFFFFFF,Text1,strlen(Text1));
/* Tell OS that we've just finished redrawing */
 __menuet__window_redraw(2);
}

/* We have to use app_main instead of main when we`re using port
   of C library for MenuetOS	
*/
int main(void)
{
 int i;
 /* We have to redraw the window at first because then we will wait
    for event with no window defined
 */
 window_redraw_proc();
 /* Then comes event loop */
 for(;;)
 {
  i=__menuet__wait_for_event(); /* Wait for event here */
  switch(i) /* Check and handle events if needed */
  {
   case 1: /* Window redraw */
    window_redraw_proc();
    continue;
   case 2: /* Key from keyboard */
    __menuet__getkey(); /* Simply pop key not to block resources */
    continue;
   case 3: /* Button was pressed */
    if(__menuet__get_button_id()==1) __menuet__sys_exit(); 
     /* If close button was pressed simply exit */
    continue;
  }
 } /* Go back to wait_for_event */
}
