#include"mcoff.h"
#include<stdlib.h>
#include<stdio.h>
#include<menuet/os.h>
#include<menuet/console.h>
#include<string.h>

extern void cprintf();
extern void _my_cs();
extern void _my_ds();

#define EX(x) \
{ (unsigned long)x, "_"#x },

static struct {
 unsigned long fn;
 char * name;
} fn_table[]={
EX(__menuet__clrscr)
EX(__menuet__define_window)
EX(__menuet__get_button_id)
EX(__menuet__getkey)
EX(__menuet__init_console)
EX(__menuet__make_button)
EX(__menuet__putch)
EX(__menuet__redraw_console)
EX(__menuet__sys_exit)
EX(__menuet__wait_for_event)
EX(__menuet__window_redraw)
EX(__menuet__write_text)
EX(_my_cs)
EX(_my_ds)
EX(cprintf)
EX(strlen)
EX(__menuet__bar)
};

#define NR_SYMS  (sizeof(fn_table)/sizeof(fn_table[0]))

static unsigned long get_sym(char * n)
{
 int i=strlen(n),j;
 dprintf("get_syn(%s)\n",n);
 for(j=0;j<NR_SYMS;j++)
 {
  if(strlen(fn_table[j].name)==i)
   if(!strncmp(fn_table[j].name,n,i)) return fn_table[j].fn;
 }
 return 0;
}
 
int mcoff_my_symlookupfn(coffobj_t * obj,unsigned long * sym_val,
 unsigned long * sym_sect,int index)
{
 SYMENT * symtab,* lookup;
 char xname[9];
 char * symnamep;
 symtab=obj->co_symtab+index;
 *sym_sect=(unsigned long)symtab->e_scnum;
 if(symtab->e_scnum>0)
 {
  *sym_val=symtab->e_value;
  return 0;
 }
 if(symtab->e.e.e_zeroes==0)
 {
  symnamep=(char *)(((long)obj->co_strtab)+symtab->e.e.e_offset);
 } else {
  symnamep=(char *)symtab->e.e_name;
  memset(xname,0,9);
  memcpy(xname,symnamep,8);
  symnamep=xname;
 }
 lookup=find_coff_symbol(obj,symnamep);
 if(lookup)
 {
  *sym_val=lookup->e_value+obj->co_sections[lookup->e_scnum-1].s_scnptr+obj->co_loadaddr;
  return 0;
 }
 dprintf("get_sym()\n");
 *sym_val=get_sym(symnamep);
 if(!*sym_val) return -1;
 return 0;
}

int app_main(void)
{
 coffobj_t * obj;
 dprintf("Trying to load\n");
 if(!(obj=mcoff_load_file("/RD/1/TUTOR5.O")))
 {
  dprintf("Load failed\n");
  return -1;
 }
 if(relocate_coff_file(obj,mcoff_my_symlookupfn)==0)
 {
  typedef void (* fn_t)(void);
  fn_t fn;
  dprintf("File relocated\n");
  fn=(fn_t)mcoff_get_ref(obj,"_app_main");
  if(!fn)
  {
   dprintf("_app_main not found\n");
   return -1;
  }
  fn();
  return 0;
 } else {
  dprintf("Relocation failed\n");
 }
 return -1;
}
