#include"mcoff.h"
#include<stdlib.h>
#include<stdio.h>

static struct {
 unsigned long fn;
 char * name;
} fn_table[]={
 (long)printf,"_printf",
 (long)puts,"_puts",
 (long)fopen,"_fopen",
 (long)fclose,"_fclose",
 (long)fwrite,"_fwrite",
};

#define NR_SYMS  (sizeof(fn_table)/sizeof(fn_table[0]))

static unsigned long get_sym(char * n)
{
 int i=strlen(n),j;
 printf("get_sym(%s)\n",n);
 for(j=0;j<NR_SYMS;j++)
 {
  if(strlen(fn_table[j].name)==i)
   if(!strncmp(fn_table[j].name,n,i)) return fn_table[j].fn;
 }
 return 0;
}
 
int mcoff_my_symlookupfn(coffobj_t * obj,unsigned long * sym_val,
 unsigned long * sym_sect,int index)
{
 SYMENT * symtab,* lookup;
 char xname[9];
 char * symnamep;
 symtab=obj->co_symtab+index;
 *sym_sect=(unsigned long)symtab->e_scnum;
 if(symtab->e_scnum>0)
 {
  *sym_val=symtab->e_value;
  return 0;
 }
 if(symtab->e.e.e_zeroes==0)
 {
  symnamep=(char *)(((long)obj->co_strtab)+symtab->e.e.e_offset);
 } else {
  symnamep=(char *)symtab->e.e_name;
  memset(xname,0,9);
  memcpy(xname,symnamep,8);
  symnamep=xname;
 }
 lookup=find_coff_symbol(obj,symnamep);
 if(lookup)
 {
  *sym_val=lookup->e_value+obj->co_sections[lookup->e_scnum-1].s_scnptr+obj->co_loadaddr;
  return 0;
 }
 printf("get_sym()\n");
 *sym_val=get_sym(symnamep);
 if(!*sym_val) return -1;
 return 0;
}

int main(void)
{
 coffobj_t * obj;
 if(!(obj=mcoff_load_file("tcoff.o")))
 {
  printf("File not found\n");
  return -1;
 }
 if(relocate_coff_file(obj,mcoff_my_symlookupfn)==0)
  printf("COFF relocated\n");
 else
 {
  printf("Unresolved symbols found\n");
  exit(-1);
 }
 printf("Starting\n\n");
 {
  typedef void (* fn_t)(void);
  fn_t fn;
  fn=(fn_t)mcoff_get_ref(obj,"_DllMain");
  if(!fn)
  {
   printf("Start symbol not found !!!\n");
   return -1;
  }
  fn();
  printf("\n\nProgram done\n\n");
 }
 return 0;
}
